package client;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;

import net.ConnectionInfo;
import net.TimeoutLimitException;

public class FriendThread extends Thread {
	private Client client;
	private ClientGuiListener listener;
	private boolean vive;
	private final int ERROR_LIMIT = 5;
	private final int REFRESH_RATE = 5000;
	public FriendThread(Client client ){
		this.client = client;
		vive = true;
	}
	public void kill(){
		this.vive = false;
	}
	public void addListener(ClientGuiListener listener){
		this.listener = listener;
	}
	public void run(){
		int contador = 0;
			while(listener == null){ // s vai rodar quando o listener for adicionado

				try {
					Thread.sleep(200);
				} catch (InterruptedException e) {
					
				}
			}
			try {
				ArrayList<String> logins = null;
				try {
					logins = client.getAmigos();
				} catch (ServerException e) {
					listener.error(e);
				}
				listener.initFriendsList(logins);
			} catch (TimeoutLimitException e1) {
				this.kill();
			} catch (IOException e1) {
				listener.error(e1);
			} catch (ClassNotFoundException e1) {
				listener.error(e1);
			}
			
		while(vive){
			try {
				Hashtable<String, ConnectionInfo> tabela = client.getFriendList();
				if(listener != null){
					listener.refreshFriendsList(tabela);
				}
			} catch (TimeoutLimitException e) {

				this.kill();
				if(listener != null){
					listener.lostConnectionToServer();
				}
				client.setOffline();
			} catch (IOException e) {
				contador++;
				if(contador >= ERROR_LIMIT){
					this.kill();
					client.setOffline();
				}
				if(listener != null){
					listener.error(e);
				}
				
			} catch (ClassNotFoundException e) {
				if(listener != null){
					listener.error(e);
				}
				contador++;
				if(contador >= ERROR_LIMIT){
					this.kill();
					client.setOffline();
				}
			} catch (ServerException e) {
				contador++;
				if(contador >= ERROR_LIMIT){
					this.kill();
					client.setOffline();
				}
				if(listener != null){
					listener.error(e);
				}
			}
			try {
				Thread.sleep(REFRESH_RATE);
			} catch (InterruptedException e) {
				continue;
			}
		}
		System.out.println("MORREU FRIEND THREAD");
	}
}
