package gui;

import java.awt.Font;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.Action;
import javax.swing.InputMap;
import javax.swing.JOptionPane;
import javax.swing.JScrollBar;
import javax.swing.KeyStroke;
import javax.swing.text.AbstractDocument;

import net.ConnectionInfo;
import net.TimeoutLimitException;

import client.AuxThread;
import client.ChatThread;
import client.ClientGuiListener;
import client.FachadaClient;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ChatWindow.java
 *
 * Created on 02/06/2011, 16:01:57
 */
/**
 *
 * @author Pedro
 */
public class ChatWindow extends javax.swing.JFrame implements ClientGuiListener{
    private String login;
    private FachadaClient fachada;
    private ConnectionInfo ci;
    private String loginCliente;
    private ExecutorService threadExecutor;
    /** Creates new form ChatWindow */
    public ChatWindow(String login, String loginCliente,FachadaClient fachada, ChatThread chatConnection, ConnectionInfo ci) {
    	this.login = login;
        this.ci = ci;
        this.fachada = fachada;
        this.loginCliente = loginCliente;
        threadExecutor =  Executors.newFixedThreadPool(1);
        if(chatConnection != null){
        	chatConnection.addListener(this);
        }
        initComponents();
    }
	public void mostrarMensagem(String error) {
		JOptionPane.showMessageDialog(null, error);
	}
	public void initChatConnection(ChatThread ct){
		ct.addListener(this);
	}


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        ScrollPane1 = new javax.swing.JScrollPane();
        areaDeChatField = new javax.swing.JTextArea();
        ScrollPane2 = new javax.swing.JScrollPane();
        mensagemField = new javax.swing.JTextArea();
        jSeparator1 = new javax.swing.JSeparator();
        enviarButton = new javax.swing.JButton();
        vozButton = new javax.swing.JButton();
        convidarButton = new javax.swing.JButton();
        loginLabel = new javax.swing.JLabel();
        statusLabel = new javax.swing.JLabel();
        ipLabel = new javax.swing.JLabel();
        Menus = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        arquivoMenuItem = new javax.swing.JMenuItem();
        setTitle("Chat com "+login);
        areaDeChatField.setAutoscrolls(true);
        areaDeChatField.setLineWrap(true);
        areaDeChatField.setColumns(20);
        areaDeChatField.setEditable(false);
        areaDeChatField.setRows(5);
        ScrollPane1.setViewportView(areaDeChatField);
        //ADICIONA ACAO DO SHIFT+ENTER
        InputMap im = mensagemField.getInputMap();
        Action acao = new NewLineAction(mensagemField);
        KeyStroke shiftEnter = KeyStroke.getKeyStroke("shift ENTER");
        im.put(shiftEnter, "shift ENTER");
        mensagemField.getActionMap().put("shift ENTER", acao);
        //REMOVE A ACAO DO ENTER
        KeyStroke remove = KeyStroke.getKeyStroke("ENTER");
        im.put(remove, "none");
        mensagemField.setColumns(20);
        mensagemField.setLineWrap(true);
        mensagemField.setRows(5);
        mensagemField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                mensagemFieldKeyPressed(evt);
            }
        });

        ScrollPane2.setViewportView(mensagemField);
        AbstractDocument doc = (AbstractDocument) mensagemField.getDocument();
        doc.setDocumentFilter(new DocumentSizeFilter(1000));

        enviarButton.setText("Enviar");
        enviarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                enviarButtonActionPerformed(evt);
            }
        });

        vozButton.setText("Voz");

        convidarButton.setText("Convidar");

        loginLabel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        loginLabel.setText(login);

        statusLabel.setText("Status dele aqui");

        ipLabel.setText("IP:Porta");

        jMenu1.setText("File");

        arquivoMenuItem.setText("Enviar Arquivo...");
        jMenu1.add(arquivoMenuItem);

        Menus.add(jMenu1);

        setJMenuBar(Menus);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 596, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()

                        .addComponent(loginLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 349, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(ipLabel)
                            .addComponent(statusLabel)))
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 596, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)

                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(enviarButton, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)

                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(vozButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(convidarButton))))

                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(loginLabel)
                        .addComponent(statusLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ipLabel)
                        .addGap(20, 20, 20)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)

                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()

                        .addComponent(vozButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)

                        .addComponent(convidarButton, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(ScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addComponent(enviarButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>
    

	private void send(){
    	String msg = mensagemField.getText();	
    	String temp = msg.replaceAll("\n", "");
    	if(!temp.equals("")){
			AuxThread aux = new AuxThread(this, fachada, this.ci, msg);
			threadExecutor.execute(aux);
			mensagemField.setText("");
			areaDeChatField.append(this.loginCliente+" diz:\n"+msg+"\n");
			this.updateScroll();
    	}
    }
    private void enviarButtonActionPerformed(java.awt.event.ActionEvent evt) {                                         
    	this.send();
    }                                        

    private void mensagemFieldKeyPressed(java.awt.event.KeyEvent evt) {
    	if(!evt.isShiftDown()){
    		if(evt.getKeyCode() == KeyEvent.VK_ENTER){
    			this.send();
    		}
    	}
     
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
            }
        });
    }
    // Variables declaration - do not modify
    private javax.swing.JMenuBar Menus;
    private javax.swing.JScrollPane ScrollPane1;
    private javax.swing.JScrollPane ScrollPane2;
    private javax.swing.JTextArea areaDeChatField;
    private javax.swing.JMenuItem arquivoMenuItem;
    private javax.swing.JButton convidarButton;
    private javax.swing.JButton enviarButton;
    private javax.swing.JLabel ipLabel;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel loginLabel;
    private javax.swing.JTextArea mensagemField;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JButton vozButton;
    // End of variables declaration
	@Override
	public void callRecieved() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void connectionReceived(ChatThread chat, ConnectionInfo ci) {
		// TODO Auto-generated method stub
	}

	@Override
	public void error(Exception e) {
		this.mostrarMensagem(e.getMessage());
	}

	@Override
	public void lostConnectionToServer() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void msgRecieved(String msg) {
		System.out.println("Recebi mensagem carai");
		areaDeChatField.append(this.login+" diz:\n"+msg+"\n");
		
		this.updateScroll();
		
		this.setVisible(true);
	}
	private void updateScroll(){
		areaDeChatField.setCaretPosition(areaDeChatField.getText().length());
	}
	@Override
	public void refreshFriendsList(Hashtable<String, ConnectionInfo> tabela) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void transferRecieved() {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void initFriendsList(ArrayList<String> logins) {
		// TODO Auto-generated method stub
		
	}
}
