package server;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Vector;

import net.ConnectionInfo;

public class User implements Serializable{

	private static final long serialVersionUID = -3434624652783830014L;
	
	private ArrayList<String> contatos;
	private String login;
	private String senha;
	private String email;
	private String twitter;
	private String nomeDeExibicao;
	private String status;
	private ConnectionInfo ci;
	
	public User( String login, String senha,
			String email, String twitter, String nomeDeExibicao, String status) {
		this.contatos = new ArrayList<String>();
		this.login = login;
		this.senha = senha;
		this.email = email;
		this.twitter = twitter;
		this.nomeDeExibicao = nomeDeExibicao;
		this.status = status;
	}
	
	public User( String login) {
		this.contatos = new ArrayList<String>();
		this.login = login;
		this.status = "offline";
		
	}
	
	@Override
	public boolean equals(Object e){
		boolean retorno = false;
		if(e instanceof User){
			if(((User)e).login == this.login){
				retorno = true;
			}
		}
		return retorno;
	}
	@Override
	public String toString(){
		return this.login +" || "+this.status;
	}
	/*
	 * getter and setters
	 */
	public ArrayList<String> getContatos() {
		return contatos;
	}
	public ConnectionInfo getConnectionInfo(){
		return this.ci;
	}
	public String getLogin() {
		return login;
	}

	public String getSenha() {
		return senha;
	}

	public void setSenha(String senha) {
		this.senha = senha;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getTwitter() {
		return twitter;
	}

	public void setTwitter(String twitter) {
		this.twitter = twitter;
	}

	public String getNomeDeExibicao() {
		return nomeDeExibicao;
	}

	public void setNomeDeExibicao(String nomeDeExibicao) {
		this.nomeDeExibicao = nomeDeExibicao;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}
	public void setConnectionInfo(ConnectionInfo info){
		this.ci = info;
	}

	
}
